type bintv = { lo: bool; hi: bool }

let is_consistent { lo= lo; hi= hi } =
  lo<=hi

let disj iv1 iv2 =
  begin
    assert(is_consistent iv1);
    assert(is_consistent iv2);
    let r= { lo= iv1.lo || iv2.lo; hi= iv1.hi || iv2.hi }
    in begin
      assert(is_consistent r);
      r
    end
  end

let conj { lo= lo1; hi= hi1 } { lo= lo2; hi= hi2 } =
  { lo= lo1 && lo2; hi= hi1 && hi2 }

let true_intv =
  { lo= true; hi= true }

let false_intv = 
  { lo= false; hi= false }

let is_true (b: bintv) =
  begin
    assert(is_consistent b);
    b.lo && b.hi 
  end

let is_false (b: bintv) =
  begin
    assert(is_consistent b);
    (not b.lo) && (not b.hi)
  end

let thin { lo= lo; hi= hi } = 
  lo=hi

let print { lo= lo; hi= hi } =
  print_string "[ ";
  if lo then print_string "T" else print_string "F";
  print_string ", ";
  if hi then print_string "T" else print_string "F";
  print_string "]"





