let reader (s: string) (n: int): int =
  (* only reads till next newline, this allows interleaved reading of input without parser *)
  let rec read_rec (k:int) =
    if k==n then k
    else
      try 
	let c= input_char stdin in begin
	s.[k]<- c;
	  if c=='\n' then k+1
	  else read_rec (k+1)
	end with
      | End_of_file -> k in
  read_rec 0
	
(* let lexinput= (Lexing.from_channel stdin) *)

let lexinput= (Lexing.from_function reader)

let parse_box (): Box.box =
  Parser.box Lexer.token lexinput

let parse_term (var: string list) =
  Parser_intern.variables:= var ;
  Parser.single_term Lexer.token lexinput

let parse_constr_intern lexinput (var: string list) =
  Parser_intern.variables:= var;  
  let constr= Parser.expr Lexer.token lexinput in
  Constr.decorate constr;
  constr

let parse_constr (var: string list) =
  parse_constr_intern lexinput var

let parse_constr_str (buf: string) (var: string list) =
  parse_constr_intern (Lexing.from_string buf) var

let parse_vars (): string list =
  Parser.var_list Lexer.token lexinput
