(* interface to semidefinite programming *)
open Interval

type 'a matrix = 'a array array 

type sdp_result =
    SDPSuccess |
    SDPUnbounded |
    SDPNotFeasible |
    SDPNoSuccess 

val sdp: interval matrix -> (int * int) -> bool -> (sdp_result * float)
(* 
  Input: 
    M: 
    v: 
    d: maximize/minimize

  Output:
    maximal/minimal value of v for a positive semidefinite matrix in M, 
*)

val sdpx: interval matrix -> float matrix -> sdp_result 
(* 
  Input: 
    M: 
    f: 

  Output:
    maximal/minimal value of objective function f for a positive semidefinite matrix in M
    f is replaced by corresponding optimizer
*)

val solver: unit -> string

val num_calls: unit -> int


